Subject: Re: [linux-next][s390] Boot hang after merge c50f05bd3c4e (sched/hrtick)

From: Peter Zijlstra <[email-masked]>
Date: Thu, 5 Mar 2026 13:12:01 +0100

On Thu, Mar 05, 2026 at 08:49:22AM +0100, Heiko Carstens wrote:
> On Wed, Mar 04, 2026 at 05:13:56PM +0100, Mikhail Zaslonko wrote:
> > Sorry, forgot to Cc a few people.
> > Adding scheduler maintainers.
> > 
> > Thanks,
> > Mikhail Zaslonko
> > 
> > On 03-Mar-26 19:31, Mikhail Zaslonko wrote:
> > > Hello,
> > > 
> > > we have kernel-next boot hang on s390 starting next-20260302.
> > > 
> > > I bisected it in linux-next to:
> > > 
> > > c50f05bd3c4e ("Merge branch into tip/master: 'sched/hrtick'")
> > > 
> > > Good:
> > >   72a2ab46f045  
> > >   d50da4b5915f  (2nd parent: sched/hrtick branch)
> > > 
> > > Bad:
> > >   c50f05bd3c4e  (merge commit)
> > > 
> > > Environment:
> > >  - s390 under z/VM
> > >  - many CPUs defined (32+)
> > >  - boot hangs early with RCU stall (see boot log excerpt below)
> 
> linux-next is currently completely broken because of this.

Turns out, that aside from something weird with ACPI PCI routing, these
two patches:

https://lkml.kernel.org/r/87bjh4zies.ffs@tglx
https://lkml.kernel.org/r/87cy1jsa4m.ffs@tglx

Make tip/sched/core, which includes:

1b8b1bb2a2fa (tip/sched/core) Merge branch 'linus' into sched/core, to resolve conflicts
c1455a120f7e Merge branch 'sched/hrtick'

work reliably on my SPR. But since you don't have
CLOCK_SOURCE_HAS_COUPLED_CLOCK_EVENT (yet) this should not affect you.

> Any idea?

Well, that all looks like timers are going missing. Which matches with
Sven saying that disabling HRTIMER_REARM_DEFERRED makes it go again.

I'm just not sure I can see why things would break between
sched/hrtick (GOOD) and 1b8b1bb2a2fa (BAD).

Looking at the diff (eg git diff d50da4b5915f..c50f05bd3c4e) show some
idle time changes to s390 and various kernel/ changes, but nothing that
stands out to me :/